/* 
 * getdate() %y checker
 * 
 * Note that UNIX systems are required only to be able to
 * represent dates up until between Jan 1 1970 and Jan 1 2038,
 * some systems may be able to handle a wider range but its
 * not required. 
 *
 * Symptons of the non handling of the range is a core dump,
 * if this occurs see below -re TOG_END
 * 
 * This test requires a file called datemsk to be in the current
 * directory with the contents "%d/%m/%y"
 *
 * Author: Andrew Josey, (ajosey@xopen.org)
 * Based on the idea seen for a  test for strptime on comp.unix.aix
 * reworked to allow for the Jan 1 1970 - Jan 1 2038 limits on 
 * some systems.
 */

#ifndef lint
static char *_version = "@(#)getdate_win.c 1.1 - 98/06/08";
#endif
/*
 * Determine window for the getdate() function.
 */
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#ifdef sun
#include <tzfile.h>
#else
#define TM_YEAR_BASE 1900
#endif

main()
{
 int i;
 struct tm tm_struct, *tm_ptr;
 char buf[9];
 int years[100];
 char s[20];

 tm_ptr = &tm_struct;

 sprintf (s, "DATEMSK=./datemsk");
 putenv(s);

/* some systems may handle 0 to 100, if so change the 38
 * to 100 and the next code block will disappear 
 */

#define TOG_START 0   
/* #define TOG_END 100  */
#define TOG_END 38    /* comment in if core dumps occur */

 for (i = TOG_START ; i < TOG_END; i++) {
  sprintf(buf, "01/01/%02d", i);
/*  printf("i=%d,template=%s\n",i, buf);*/
  tm_ptr = getdate (buf);
  years[i] = tm_ptr->tm_year + TM_YEAR_BASE;
/*  printf("YEAR=%d\n", years[i]);*/
 }

#if (TOG_END - 38 == 0)
 for (i = 69; i < 100; i++) {
  sprintf(buf, "01/01/%02d", i);
/*  printf("i=%d,template=%s\n",i, buf);*/
  tm_ptr = getdate (buf);
  years[i] = tm_ptr->tm_year + TM_YEAR_BASE;
/*  printf("YEAR=%d\n", years[i]);*/
 }
#endif

 printf("getdate(3C) window: %04d-", years[0]);
 for (i = 1; i <  TOG_END; i++) {
  if (years[i-1] / 100 != years[i] / 100)
   printf("%04d %04d-", years[i-1], years[i]);
 }
 printf("%04d ", years[TOG_END-1]);

#if (TOG_END - 38 == 0)

 printf("%04d-", years[69]);
 for (i = 70; i <  100; i++) {
  if (years[i-1] / 100 != years[i] / 100)
   printf("%04d %04d-", years[i-1], years[i]);
 }
 printf("%04d\n", years[99]);
#endif

 exit(0);
 return (0);  /* quiet lint gripes */
}


